/*
 *
 * (c) September 1998 by Mauro Marinilli
 *
 */


import com.sun.java.swing.*;
import com.sun.java.swing.tree.*;
import java.io.*;
import java.awt.*;
import javax.media.j3d.*;


public class SceneTreePanel extends JPanel {
  private JTree tree;

//  public SceneTreePanel( BranchGroup g ) {
//    this( new SceneTreeModel( g ) );
//  }

  public SceneTreePanel( SceneTreeModel model ) {
    tree = new JTree( model ) {
      public String convertValueToText(Object value, boolean selected,
                     boolean expanded, boolean leaf, int row,
                     boolean hasFocus) {
        return value.toString();
      }
    };

    tree.setRootVisible( false );
    tree.setShowsRootHandles( true );
    tree.putClientProperty( "JTree.lineStyle", "Angled" );

    setLayout( new BorderLayout() );
    add( tree, BorderLayout.CENTER );
  }

  public JTree getTree() {
   return tree;
  }
}


