/*
 *
 * (c) September 1998 by Mauro Marinilli
 *
 */


import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;


public class Simple3D extends VU {
    SimpleUniverse su;

    public BranchGroup createSceneGraph() {
	BranchGroup objRoot = new BranchGroup();

	Transform3D spin = new Transform3D();
	Transform3D tempspin = new Transform3D();

        spin.rotX(Math.PI/4.0d);
	tempspin.rotY(Math.PI/5.0d);
        spin.mul(tempspin);

	TransformGroup objTrans = new TransformGroup(spin);
	objRoot.addChild(objTrans);

    objTrans.setCapability(objRoot.ALLOW_CHILDREN_READ);
	objTrans.addChild(new ColorCube(0.4));


////

    objTrans.addChild(new ColorCube(0.3));
    objTrans.setCapability(objRoot.ALLOW_CHILDREN_READ);
    objTrans.addChild(new ColorCube(0.1));
    objTrans.setCapability(objRoot.ALLOW_CHILDREN_READ);




////


  objRoot.setCapability(objRoot.ALLOW_CHILDREN_READ);
  objRoot.compile();

	return objRoot;
    }


    public Simple3D() {
        setLayout(new BorderLayout());
        Canvas3D c = new Canvas3D(null);
        add("Center", c);

        BranchGroup scene = createSceneGraph();

        // SimpleUniverse is a Convenience Utility class
        SimpleUniverse u = new SimpleUniverse(c);
        su = u;

        u.getViewingPlatform().setNominalViewingTransform();

        u.addBranchGraph(scene);
    }


  public VirtualUniverse getVU(){
    return (VirtualUniverse)su;
  }


    public static void main(String[] args) {

  Simple3D he = new Simple3D();
  Frame frame = new MainFrame(he, 256, 256);
    }
}
